//****************************//
//                            //
//  POP3Checker Ver:sample1.0 //
//  Copyright: Sam Zhao       //
//  2005 Niigata City Japan   //
//                            //
//****************************//
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
//StringReader
using System.IO;
//Xbh
using System.Threading;
//MD5
using System.Security.Cryptography;
//Encoding
using System.Text;

namespace POP3Checker
{
	/// <summary>
	/// Form1 ̊Tv̐łB
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox tbox_popServer;
		private System.Windows.Forms.TextBox tbox_id;
		private System.Windows.Forms.TextBox tbox_pass;
		private System.Windows.Forms.RadioButton rbtn_up;
		private System.Windows.Forms.RadioButton rbtn_apop;
		private System.Windows.Forms.Button btn_connect;
		private string infoMsg = "";
		private string timestamp = "";
		private System.Windows.Forms.ListView listView_subject;
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.ColumnHeader columnHeader2;
		private System.Windows.Forms.TextBox tbox_count;
		private System.Windows.Forms.Label label4;
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			//
			// TODO: InitializeComponent ĂяǒɁARXgN^ R[hǉĂB
			//
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.listView_subject = new System.Windows.Forms.ListView();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.btn_connect = new System.Windows.Forms.Button();
			this.tbox_popServer = new System.Windows.Forms.TextBox();
			this.tbox_id = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.tbox_pass = new System.Windows.Forms.TextBox();
			this.rbtn_up = new System.Windows.Forms.RadioButton();
			this.rbtn_apop = new System.Windows.Forms.RadioButton();
			this.tbox_count = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// listView_subject
			// 
			this.listView_subject.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																							   this.columnHeader1,
																							   this.columnHeader2});
			this.listView_subject.Location = new System.Drawing.Point(8, 8);
			this.listView_subject.Name = "listView_subject";
			this.listView_subject.Size = new System.Drawing.Size(344, 392);
			this.listView_subject.TabIndex = 0;
			this.listView_subject.View = System.Windows.Forms.View.Details;
			// 
			// columnHeader1
			// 
			this.columnHeader1.Text = "ԍ";
			// 
			// columnHeader2
			// 
			this.columnHeader2.Text = "";
			this.columnHeader2.Width = 258;
			// 
			// btn_connect
			// 
			this.btn_connect.Location = new System.Drawing.Point(376, 376);
			this.btn_connect.Name = "btn_connect";
			this.btn_connect.TabIndex = 1;
			this.btn_connect.Text = "`FbN";
			this.btn_connect.Click += new System.EventHandler(this.btn_connect_Click);
			// 
			// tbox_popServer
			// 
			this.tbox_popServer.Location = new System.Drawing.Point(360, 24);
			this.tbox_popServer.Name = "tbox_popServer";
			this.tbox_popServer.Size = new System.Drawing.Size(112, 19);
			this.tbox_popServer.TabIndex = 2;
			this.tbox_popServer.Text = "";
			// 
			// tbox_id
			// 
			this.tbox_id.Location = new System.Drawing.Point(360, 80);
			this.tbox_id.Name = "tbox_id";
			this.tbox_id.Size = new System.Drawing.Size(112, 19);
			this.tbox_id.TabIndex = 3;
			this.tbox_id.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(360, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(100, 16);
			this.label1.TabIndex = 4;
			this.label1.Text = "POPT[oAhX";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(360, 64);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(48, 16);
			this.label2.TabIndex = 5;
			this.label2.Text = "[UID";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(360, 112);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(56, 16);
			this.label3.TabIndex = 6;
			this.label3.Text = "pX[h";
			// 
			// tbox_pass
			// 
			this.tbox_pass.Location = new System.Drawing.Point(360, 128);
			this.tbox_pass.Name = "tbox_pass";
			this.tbox_pass.PasswordChar = '*';
			this.tbox_pass.Size = new System.Drawing.Size(112, 19);
			this.tbox_pass.TabIndex = 7;
			this.tbox_pass.Text = "";
			// 
			// rbtn_up
			// 
			this.rbtn_up.Checked = true;
			this.rbtn_up.Location = new System.Drawing.Point(360, 176);
			this.rbtn_up.Name = "rbtn_up";
			this.rbtn_up.Size = new System.Drawing.Size(96, 24);
			this.rbtn_up.TabIndex = 8;
			this.rbtn_up.TabStop = true;
			this.rbtn_up.Text = "USER/PASS";
			// 
			// rbtn_apop
			// 
			this.rbtn_apop.Location = new System.Drawing.Point(360, 208);
			this.rbtn_apop.Name = "rbtn_apop";
			this.rbtn_apop.Size = new System.Drawing.Size(64, 24);
			this.rbtn_apop.TabIndex = 9;
			this.rbtn_apop.Text = "APOP";
			// 
			// tbox_count
			// 
			this.tbox_count.Location = new System.Drawing.Point(368, 304);
			this.tbox_count.Name = "tbox_count";
			this.tbox_count.TabIndex = 11;
			this.tbox_count.Text = "";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(368, 288);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(72, 16);
			this.label4.TabIndex = 12;
			this.label4.Text = "bZ[W";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(480, 413);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.tbox_count);
			this.Controls.Add(this.rbtn_apop);
			this.Controls.Add(this.rbtn_up);
			this.Controls.Add(this.tbox_pass);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.tbox_id);
			this.Controls.Add(this.tbox_popServer);
			this.Controls.Add(this.btn_connect);
			this.Controls.Add(this.listView_subject);
			this.Name = "Form1";
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// AvP[ṼC Gg |CgłB
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void btn_connect_Click(object sender, System.EventArgs e)
		{
			listView_subject.Items.Clear();
			Thread tMain = new Thread(new ThreadStart(run));
			tMain.IsBackground = true;
			tMain.Start();
		}
		private void run()
		{
			POPConnection pop = new POPConnection();
			if(tbox_popServer.Text != String.Empty)
				pop.HostName = tbox_popServer.Text;

			///////////////////////////
			///POPT[oɐڑ
			///////////////////////////
			if(!pop.Connect(out infoMsg))
			{
				MessageBox.Show(infoMsg);
				return;
			}
			infoMsg = pop.GetLine();
			timestamp = GetTimeStamp(infoMsg);

			///////////////////////////
			///F
			///////////////////////////
			if(rbtn_up.Checked)
			{//USER/PASSF
				pop.SendDataToServer("USER " + tbox_id.Text);
				infoMsg = pop.GetLine();
				if(!infoMsg.StartsWith("+OK"))
				{
					pop.Disconnect();
					MessageBox.Show(infoMsg);
					return;
				}
				pop.SendDataToServer("PASS " + tbox_pass.Text);
				infoMsg = pop.GetLine();
				if(!infoMsg.StartsWith("+OK"))
				{
					pop.Disconnect();
					MessageBox.Show(infoMsg);
					return;
				}
			}
			else
			{//APOPF
				if(timestamp == null)
				{
					pop.Disconnect();
					return;
				}
				string myDigest = GetMD5Digest(timestamp + tbox_pass.Text);
				pop.SendDataToServer("APOP " + tbox_id.Text + " " + myDigest);
				infoMsg = pop.GetLine();
				if(!infoMsg.StartsWith("+OK"))
				{
					pop.Disconnect();
					MessageBox.Show(infoMsg);
					return;
				}
			}

			///////////////////////////////////////
			///Xv[ɂ郁bZ[W`FbN
			///////////////////////////////////////
			pop.SendDataToServer("STAT");
			infoMsg = pop.GetLine();
			int count = MsgCount(infoMsg);
			if(count < 1)
			{
				tbox_count.Text = count.ToString();
				pop.Disconnect();
				return;
			}
			tbox_count.Text = count.ToString();

			//////////////////////////
			///bZ[W̌\
			//////////////////////////
			for(int i=1;i<=count;i++)
			{
				pop.SendDataToServer("TOP " + i.ToString() + " 0");
				AddToListView(pop.GetLines(),i);
			}

			///////////////////////
			///RlNVؒf
			///////////////////////
			pop.SendDataToServer("QUIT");
			infoMsg = pop.GetLine();
			pop.Disconnect();
		}

		/// <summary>
		/// POP3T[oɐڑƂ̃X|XbZ[W
		/// ^CX^vo
		/// </summary>
		/// <param name="input"></param>
		/// <returns></returns>
		private string GetTimeStamp(string input)
		{
			try
			{
				int x = input.IndexOf("<");
				int y = input.IndexOf(">");
				return input.Substring(x,y-x+1);
			}
			catch
			{
				return null;
			}
		}

		/// <summary>
		/// MD5nbV擾
		/// </summary>
		/// <param name="input"></param>
		/// <returns></returns>
		private string GetMD5Digest(string input)
		{
			byte[] bb = Encoding.Default.GetBytes(input);
			byte[] cc = new MD5CryptoServiceProvider().ComputeHash(bb);
			string output = "";
			foreach(byte c in cc)
			{
				output += c.ToString("X2");
			}
			return output.ToLower();
		}

		/// <summary>
		/// STATR}hɑ΂āAT[o
		/// +OK count size
		/// ƂtH[}bg̕߂B̃\bh͐^񒆂
		/// counto
		/// </summary>
		/// <param name="input"></param>
		/// <returns></returns>
		private int MsgCount(string input)
		{
			string[] ss = input.Split(' ');
			return int.Parse(ss[1]);
		}

		/// <summary>
		/// ListViewɃbZ[W̌ɒǉ
		/// ĂB
		/// </summary>
		/// <param name="input"></param>
		/// <param name="index"></param>
		private void AddToListView(string input,int index)
		{
			ListViewItem myItem = new ListViewItem(index.ToString());
			myItem.SubItems.Add(GetSubject(input));
			listView_subject.Items.Add(myItem);
			listView_subject.EnsureVisible(index-1);
		}
		private string GetSubject(string input)
		{
			StringReader sReader = new StringReader(input);
			string ss = "";
			string tmp = "";
			while((ss = sReader.ReadLine()) != null)
			{
				ss = ss.TrimEnd();
				if(ss.Length<7)
					continue;
				tmp = ss.Substring(0,7).ToLower();
				if(tmp.Equals("subject"))
				{
					string mysubject = "";
					mysubject = Subject.GetSubject(ss);
					while((ss = sReader.ReadLine())!=null)
					{
						if(!ss.StartsWith(" ") && !ss.StartsWith("	"))
							break;
						mysubject += Subject.GetSubject(ss);
					}
					ss = mysubject;
					break;
				}
			}
			return ss;
		}
	}
}
