//****************************//
//                            //
//  MailSender Ver:sample     //
//  Copyright: Sam Zhao       //
//  2005 Niigata City Japan   //
//                            //
//****************************//
using System;
//StreamReader
using System.IO;
//Encoding
using System.Text;
//TcpClient
using System.Net.Sockets;

namespace MailSender
{
	/// <summary>
	/// SMTP ̊Tv̐łB
	/// </summary>
	public class SmtpConnection
	{
		public SmtpConnection()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
		}
		private NetworkStream netStream = null;
		private string CRLF = "\r\n";
		private TcpClient tcpC = null;

		/// <summary>
		/// SMTPT[õAhX擾
		/// </summary>
		private string hostname = "127.0.0.1";
		public string HostName
		{
			get{return hostname;}
			set{hostname = value;}
		}

		/// <summary>
		/// SMTPT[oTCP|[g擾
		/// </summary>
		private int port = 25;
		public int Port
		{
			get{return port;}
			set{port = value;}
		}

		/// <summary>
		/// SMTPT[oɐڑ
		/// </summary>
		/// <param name="tcpC"></param>
		/// <param name="connectionMsg"></param>
		/// <returns></returns>
		public bool Connect(out string connectionMsg)
		{
			connectionMsg = "";
			try
			{
				tcpC = new TcpClient(hostname,port);
				netStream = tcpC.GetStream();
				connectionMsg = "T[o " + hostname + "ɐڑ" + CRLF;
				return true;
			}
			catch(Exception ee)
			{
				connectionMsg = ee.Message;
				return false;
			}
		}

		/// <summary>
		/// RlNV؂
		/// </summary>
		/// <returns></returns>
		public bool DisConnect()
		{
			try
			{
				netStream.Close();
				tcpC.Close();
				return true;
			}
			catch
			{
				return false;
			}
		}

		/// <summary>
		/// SMTPT[osmtpR}h𑗐M
		/// </summary>
		/// <param name="command"></param>
		/// <returns></returns>
		public bool SendDataToServer(string command)
		{
			byte[] bb;
			bb = Encoding.ASCII.GetBytes(command + CRLF);
			try
			{
				netStream.Write(bb,0,bb.Length);
				return true;
			}
			catch
			{
				return false;
			}
		}

		/// <summary>
		/// T[õX|XbZ[W擾
		/// </summary>
		/// <param name="responseMsg"></param>
		/// <returns></returns>
		public int CheckResponse(out string responseMsg)
		{
			int responseCode = 0;
			responseMsg = "";
			string ss = "";
			try
			{
				StreamReader sReader = new StreamReader(netStream,Encoding.ASCII);
				while((ss = sReader.ReadLine()) != null)
				{
					responseMsg += (ss + CRLF);
					responseCode = int.Parse(ss.Substring(0,3));
					if(ss.Substring(3,1).Equals(" "))
						break;
				}
			}
			catch
			{
			}
			return responseCode;
		}
	}
}
